git-stash.shon commit Merge branch 'js/diff-verbose-submodule' (d39d667)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [-k|--keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15. git-sh-setup
  16require_work_tree
  17cd_to_toplevel
  18
  19TMP="$GIT_DIR/.git-stash.$$"
  20trap 'rm -f "$TMP-*"' 0
  21
  22ref_stash=refs/stash
  23
  24if git config --get-colorbool color.interactive; then
  25       help_color="$(git config --get-color color.interactive.help 'red bold')"
  26       reset_color="$(git config --get-color '' reset)"
  27else
  28       help_color=
  29       reset_color=
  30fi
  31
  32no_changes () {
  33        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  34        git diff-files --quiet --ignore-submodules
  35}
  36
  37clear_stash () {
  38        if test $# != 0
  39        then
  40                die "git stash clear with parameters is unimplemented"
  41        fi
  42        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  43        then
  44                git update-ref -d $ref_stash $current
  45        fi
  46}
  47
  48create_stash () {
  49        stash_msg="$1"
  50
  51        git update-index -q --refresh
  52        if no_changes
  53        then
  54                exit 0
  55        fi
  56
  57        # state of the base commit
  58        if b_commit=$(git rev-parse --verify HEAD)
  59        then
  60                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  61        else
  62                die "You do not have the initial commit yet"
  63        fi
  64
  65        if branch=$(git symbolic-ref -q HEAD)
  66        then
  67                branch=${branch#refs/heads/}
  68        else
  69                branch='(no branch)'
  70        fi
  71        msg=$(printf '%s: %s' "$branch" "$head")
  72
  73        # state of the index
  74        i_tree=$(git write-tree) &&
  75        i_commit=$(printf 'index on %s\n' "$msg" |
  76                git commit-tree $i_tree -p $b_commit) ||
  77                die "Cannot save the current index state"
  78
  79        if test -z "$patch_mode"
  80        then
  81
  82                # state of the working tree
  83                w_tree=$( (
  84                        rm -f "$TMP-index" &&
  85                        cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  86                        GIT_INDEX_FILE="$TMP-index" &&
  87                        export GIT_INDEX_FILE &&
  88                        git read-tree -m $i_tree &&
  89                        git add -u &&
  90                        git write-tree &&
  91                        rm -f "$TMP-index"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                -k|--keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                --)
 149                        shift
 150                        break
 151                        ;;
 152                -*)
 153                        echo "error: unknown option for 'stash save': $1"
 154                        usage
 155                        ;;
 156                *)
 157                        break
 158                        ;;
 159                esac
 160                shift
 161        done
 162
 163        stash_msg="$*"
 164
 165        git update-index -q --refresh
 166        if no_changes
 167        then
 168                say 'No local changes to save'
 169                exit 0
 170        fi
 171        test -f "$GIT_DIR/logs/$ref_stash" ||
 172                clear_stash || die "Cannot initialize stash"
 173
 174        create_stash "$stash_msg"
 175
 176        # Make sure the reflog for stash is kept.
 177        : >>"$GIT_DIR/logs/$ref_stash"
 178
 179        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 180                die "Cannot save the current status"
 181        say Saved working directory and index state "$stash_msg"
 182
 183        if test -z "$patch_mode"
 184        then
 185                git reset --hard ${GIT_QUIET:+-q}
 186
 187                if test -n "$keep_index" && test -n $i_tree
 188                then
 189                        git read-tree --reset -u $i_tree
 190                fi
 191        else
 192                git apply -R < "$TMP-patch" ||
 193                die "Cannot remove worktree changes"
 194
 195                if test -z "$keep_index"
 196                then
 197                        git reset
 198                fi
 199        fi
 200}
 201
 202have_stash () {
 203        git rev-parse --verify $ref_stash >/dev/null 2>&1
 204}
 205
 206list_stash () {
 207        have_stash || return 0
 208        git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
 209        sed -n -e 's/^[.0-9a-f]* refs\///p'
 210}
 211
 212show_stash () {
 213        flags=$(git rev-parse --no-revs --flags "$@")
 214        if test -z "$flags"
 215        then
 216                flags=--stat
 217        fi
 218
 219        w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
 220        b_commit=$(git rev-parse --verify "$w_commit^") &&
 221        git diff $flags $b_commit $w_commit
 222}
 223
 224apply_stash () {
 225        unstash_index=
 226
 227        while test $# != 0
 228        do
 229                case "$1" in
 230                --index)
 231                        unstash_index=t
 232                        ;;
 233                -q|--quiet)
 234                        GIT_QUIET=t
 235                        ;;
 236                *)
 237                        break
 238                        ;;
 239                esac
 240                shift
 241        done
 242
 243        if test $# = 0
 244        then
 245                have_stash || die 'Nothing to apply'
 246        fi
 247
 248        # stash records the work tree, and is a merge between the
 249        # base commit (first parent) and the index tree (second parent).
 250        s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
 251        w_tree=$(git rev-parse --quiet --verify "$s:") &&
 252        b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
 253        i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
 254                die "$*: no valid stashed state found"
 255
 256        git update-index -q --refresh &&
 257        git diff-files --quiet --ignore-submodules ||
 258                die 'Cannot apply to a dirty working tree, please stage your changes'
 259
 260        # current index state
 261        c_tree=$(git write-tree) ||
 262                die 'Cannot apply a stash in the middle of a merge'
 263
 264        unstashed_index_tree=
 265        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 266                        test "$c_tree" != "$i_tree"
 267        then
 268                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 269                test $? -ne 0 &&
 270                        die 'Conflicts in index. Try without --index.'
 271                unstashed_index_tree=$(git write-tree) ||
 272                        die 'Could not save index tree'
 273                git reset
 274        fi
 275
 276        eval "
 277                GITHEAD_$w_tree='Stashed changes' &&
 278                GITHEAD_$c_tree='Updated upstream' &&
 279                GITHEAD_$b_tree='Version stash was based on' &&
 280                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 281        "
 282
 283        if test -n "$GIT_QUIET"
 284        then
 285                export GIT_MERGE_VERBOSITY=0
 286        fi
 287        if git merge-recursive $b_tree -- $c_tree $w_tree
 288        then
 289                # No conflict
 290                if test -n "$unstashed_index_tree"
 291                then
 292                        git read-tree "$unstashed_index_tree"
 293                else
 294                        a="$TMP-added" &&
 295                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 296                        git read-tree --reset $c_tree &&
 297                        git update-index --add --stdin <"$a" ||
 298                                die "Cannot unstage modified files"
 299                        rm -f "$a"
 300                fi
 301                squelch=
 302                if test -n "$GIT_QUIET"
 303                then
 304                        squelch='>/dev/null 2>&1'
 305                fi
 306                eval "git status $squelch" || :
 307        else
 308                # Merge conflict; keep the exit status from merge-recursive
 309                status=$?
 310                if test -n "$unstash_index"
 311                then
 312                        echo >&2 'Index was not unstashed.'
 313                fi
 314                exit $status
 315        fi
 316}
 317
 318drop_stash () {
 319        have_stash || die 'No stash entries to drop'
 320
 321        while test $# != 0
 322        do
 323                case "$1" in
 324                -q|--quiet)
 325                        GIT_QUIET=t
 326                        ;;
 327                *)
 328                        break
 329                        ;;
 330                esac
 331                shift
 332        done
 333
 334        if test $# = 0
 335        then
 336                set x "$ref_stash@{0}"
 337                shift
 338        fi
 339        # Verify supplied argument looks like a stash entry
 340        s=$(git rev-parse --verify "$@") &&
 341        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 342        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 343        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 344                die "$*: not a valid stashed state"
 345
 346        git reflog delete --updateref --rewrite "$@" &&
 347                say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 348
 349        # clear_stash if we just dropped the last stash entry
 350        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 351}
 352
 353apply_to_branch () {
 354        have_stash || die 'Nothing to apply'
 355
 356        test -n "$1" || die 'No branch name specified'
 357        branch=$1
 358
 359        if test -z "$2"
 360        then
 361                set x "$ref_stash@{0}"
 362        fi
 363        stash=$2
 364
 365        git checkout -b $branch $stash^ &&
 366        apply_stash --index $stash &&
 367        drop_stash $stash
 368}
 369
 370# The default command is "save" if nothing but options are given
 371seen_non_option=
 372for opt
 373do
 374        case "$opt" in
 375        -*) ;;
 376        *) seen_non_option=t; break ;;
 377        esac
 378done
 379
 380test -n "$seen_non_option" || set "save" "$@"
 381
 382# Main command set
 383case "$1" in
 384list)
 385        shift
 386        if test $# = 0
 387        then
 388                set x -n 10
 389                shift
 390        fi
 391        list_stash "$@"
 392        ;;
 393show)
 394        shift
 395        show_stash "$@"
 396        ;;
 397save)
 398        shift
 399        save_stash "$@"
 400        ;;
 401apply)
 402        shift
 403        apply_stash "$@"
 404        ;;
 405clear)
 406        shift
 407        clear_stash "$@"
 408        ;;
 409create)
 410        if test $# -gt 0 && test "$1" = create
 411        then
 412                shift
 413        fi
 414        create_stash "$*" && echo "$w_commit"
 415        ;;
 416drop)
 417        shift
 418        drop_stash "$@"
 419        ;;
 420pop)
 421        shift
 422        if apply_stash "$@"
 423        then
 424                test -z "$unstash_index" || shift
 425                drop_stash "$@"
 426        fi
 427        ;;
 428branch)
 429        shift
 430        apply_to_branch "$@"
 431        ;;
 432*)
 433        case $# in
 434        0)
 435                save_stash &&
 436                say '(To restore them type "git stash apply")'
 437                ;;
 438        *)
 439                usage
 440        esac
 441        ;;
 442esac